Groovy Documentation

## org.vertx.groovy.core.streams
[Groovy] Class Pump

    java.lang.Object
      org.vertx.groovy.core.streams.Pump

    class Pump

Pumps data from a ReadStream to a WriteStream and performs flow control where necessary to prevent the write stream from getting overloaded.

Instances of this class read bytes from a ReadStream and write them to a WriteStream. If data can be read faster than it can be written this could result in the write queue of the WriteStream growing without bound, eventually causing it to exhaust all available RAM.

To prevent this, after each write, instances of this class check whether the write queue of the WriteStream is full, and if so, the ReadStream is paused, and a `drainHandler` is set on the WriteStream. When the WriteStream has processed half of its backlog, the `drainHandler` will be called, which results in the pump resuming the ReadStream.

This class can be used to pump from any ReadStream to any WriteStream, e.g. from an HttpServerRequest to an AsyncFile, or from NetSocket to a WebSocket.

Authors:
  Tim Fox

Method Summary
`static Pump` | `createPump(ReadStream rs, WriteStream ws)` Create a new `Pump` with the given `ReadStream` and `WriteStream`
`int` | `getBytesPumped()` Return the total number of bytes pumped by this pump.
`void` | `setWriteQueueMaxSize(int maxSize)` Set the write queue max size to `maxSize`
`void` | `start()` Start the Pump.
`void` | `stop()` Stop the Pump.

Methods inherited from class java.lang.Object
java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()

Method Detail

### createPump

    static Pump createPump(ReadStream rs, WriteStream ws)

  Create a new `Pump` with the given `ReadStream` and `WriteStream`

### getBytesPumped

    int getBytesPumped()

  Return the total number of bytes pumped by this pump.

### setWriteQueueMaxSize

    void setWriteQueueMaxSize(int maxSize)

  Set the write queue max size to `maxSize`

### start

    void start()

  Start the Pump. The Pump can be started and stopped multiple times.

### stop

    void stop()

  Stop the Pump. The Pump can be started and stopped multiple times.

Groovy Documentation